#ifndef _TEST_TPCEXTENSIONS_H_
#define _TEST_TPCEXTENSIONS_H_
/*****************************************************************************/

/*****************************************************************************/
#include "tpcclibConfig.h"
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <ctype.h>
#include <math.h>
/*****************************************************************************/

/*****************************************************************************/
/* stringext */
int test_strTokenNr(TPCSTATUS *status);
int test_strTokenNCpy(TPCSTATUS *status);
int test_strChrCount(TPCSTATUS *status);
int test_strReplaceChar(TPCSTATUS *status);
#ifndef HAVE_STRNDUP // Test only if own implementation is used
int test_strndup(TPCSTATUS *status);
#endif
int test_strstrNoQuotation(TPCSTATUS *status);
int test_strncpyCleanSpaces(TPCSTATUS *status);
int test_strCleanSpaces(TPCSTATUS *status);
int test_strncpyClean(TPCSTATUS *status);
int test_strClean(TPCSTATUS *status);
int test_strTokenDup(TPCSTATUS *status);
int test_strInPars(TPCSTATUS *status);
int test_strCleanPars(TPCSTATUS *status);
int test_strncatInt(TPCSTATUS *status);
int test_strncatDouble(TPCSTATUS *status);
int test_strncatIntZ(TPCSTATUS *status);
#ifndef HAVE_STRNLEN // Test only if own implementation is used
int test_strnlen(TPCSTATUS *status);
#endif
#ifndef HAVE_STRLCAT // Test only if own implementation is used
int test_strlcat(TPCSTATUS *status);
#endif
#ifndef HAVE_STRLCPY // Test only if own implementation is used
int test_strlcpy(TPCSTATUS *status);
#endif
int test_strIsSpaceOnly(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* decpoint */
int test_strIsValidNumber(TPCSTATUS *status);
int test_atofVerified(TPCSTATUS *status);
int test_atofCheck(TPCSTATUS *status);
int test_strHaveDecimalComma(TPCSTATUS *status);
int test_strHaveDecimalSeparator(TPCSTATUS *status);
int test_atofList(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* filename */
int test_filenameRmPath(TPCSTATUS *status);
int test_filenameRmFile(TPCSTATUS *status);
int test_filenameRmExtension(TPCSTATUS *status);
int test_filenameRmExtensions(TPCSTATUS *status);
int test_fnmatch(TPCSTATUS *status);
int test_fncasematch(TPCSTATUS *status);
int test_filenameGetExtension(TPCSTATUS *status);
int test_filenameGetExtensions(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* proginfo */
int test_tpcProcessStdOptions(TPCSTATUS *status);
int test_tpcPrintUsage(TPCSTATUS *status);
int test_tpcPrintBuild(TPCSTATUS *status);
int test_tpcProgramName(TPCSTATUS *status);
int test_tpcYesNo(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* units */
int test_unitName(TPCSTATUS *status);
int test_unitIdentify(TPCSTATUS *status);
int test_unitIdentifyFilename(TPCSTATUS *status);
int test_unitIsDistance(TPCSTATUS *status);
int test_unitIsTime(TPCSTATUS *status);
int test_unitIsVolume(TPCSTATUS *status);
int test_unitIsMass(TPCSTATUS *status);
int test_unitIsMole(TPCSTATUS *status);
int test_unitIsRadioactivity(TPCSTATUS *status);
int test_unitIsCombinatorial(TPCSTATUS *status);
int test_unitConversionFactor(TPCSTATUS *status);
int test_unitInverse(TPCSTATUS *status);
int test_unitDividerHasVolume(TPCSTATUS *status);
int test_unitDividerHasMass(TPCSTATUS *status);
int test_unitCombination(TPCSTATUS *status);
int test_unitDividerMassVolumeConversion(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* statusmsg */
int test_statusPrint(TPCSTATUS *status);
int test_errorMsg(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* readasciifile */
int test_asciiFileSize(TPCSTATUS *status);
int test_asciiFileRead(TPCSTATUS *status);
int test_asciiCommentLine(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* datetime */
int test_strDateValid(TPCSTATUS *status);
int test_strDateValid2(TPCSTATUS *status);
int test_strDateValid3(TPCSTATUS *status);
int test_strDateValid4(TPCSTATUS *status);
int test_strTimeValid(TPCSTATUS *status);
int test_strDateTimeValid(TPCSTATUS *status);
int test_strDateTimeRead(TPCSTATUS *status);
int test_strDateRead(TPCSTATUS *statuse);
int test_time_to_tm(TPCSTATUS *status);
int test_tmDifference(TPCSTATUS *status);
int test_tmAdd(TPCSTATUS *status);
int test_strDateTimeDifference(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* studynr */
int test_studynrVerify(TPCSTATUS *status);
int test_studynrStandardize(TPCSTATUS *status);
int test_studynrFromFilename(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* doubleutil */
int test_doubleMatch(TPCSTATUS *status);
int test_doubleMatchRel(TPCSTATUS *status);
int test_doubleMachEps(TPCSTATUS *status);
int test_doubleCopy(TPCSTATUS *status);
int test_doubleMaxIndex(TPCSTATUS *status);
int test_doubleSum(TPCSTATUS *status);
int test_doubleMean(TPCSTATUS *status);
int test_doubleGetWithUnit(TPCSTATUS *status);
int test_doubleSpanPositives(TPCSTATUS *status);
int test_doubleCSpanPositives(TPCSTATUS *status);
int test_doubleNonzeroes(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* floatutil */
int test_floatMatch(TPCSTATUS *status);
int test_floatMatchRel(TPCSTATUS *status);
int test_floatMachEps(TPCSTATUS *status);
int test_floatCopy(TPCSTATUS *status);
int test_floatMaxIndex(TPCSTATUS *status);
int test_floatSum(TPCSTATUS *status);
int test_floatMean(TPCSTATUS *status);
int test_floatGetWithUnit(TPCSTATUS *status);
int test_floatSpanPositives(TPCSTATUS *status);
int test_floatCSpanPositives(TPCSTATUS *status);
int test_floatNonzeroes(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* intutil */
int test_atoiCheck(TPCSTATUS *status);
int test_intlistInit(TPCSTATUS *status);
int test_intlistFree(TPCSTATUS *status);
int test_intlistAdd(TPCSTATUS *status);
int test_intlistSort(TPCSTATUS *status);
int test_intlistAddFromString(TPCSTATUS *status);
int test_intlistExpandFromString(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* roiname */
int test_roinameSubpart(TPCSTATUS *status);
int test_roinameEditByTemplate(TPCSTATUS *status);
int test_roinameAddField(TPCSTATUS *status);
int test_roinameExists(TPCSTATUS *status);
int test_roinameMatch(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* endian */
int test_endianLittle(TPCSTATUS *status);
int test_swap(TPCSTATUS *status);
int test_swabip(TPCSTATUS *status);
int test_swawbip(TPCSTATUS *status);
int test_swawip(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
#endif /* TEST_TPCEXTENSIONS */
