/*****************************************************************************/
#include "tpcclibConfig.h"
/*****************************************************************************/
#include "tpcextensions.h"
#include "test_tpcimage.h"
/*****************************************************************************/

/*****************************************************************************/
int test_imgReadNifti1(
  TPCSTATUS *status
) {
  int verbose=0; if(status!=NULL) verbose=status->verbose;
  statusSet(status, __func__, __FILE__, __LINE__, 0);
  if(verbose>0) {
    printf("\n=====================================\n");
    printf("\n%s\n", __func__);
    printf("\n=====================================\n");
  }

  return(0);
}
/*****************************************************************************/

/*****************************************************************************/
int test_imgWriteNifti1(
  TPCSTATUS *status
) {
  int verbose=0; if(status!=NULL) verbose=status->verbose;
  statusSet(status, __func__, __FILE__, __LINE__, 0);
  if(verbose>0) {
    printf("\n=====================================\n");
    printf("\n%s\n", __func__);
    printf("\n=====================================\n");
  }

  int ret;

  /* Does not crash with NULL input */
  ret=imgWriteNifti1(NULL, NULL, NULL);
  if(ret==TPCERROR_OK) return 1;

  IMG img; imgInit(&img);

  if(verbose>1) {printf("empty IMG\n"); fflush(stdout);}
  ret=imgWriteNifti1(&img, "nii/imgwritenifti1a", status);
  if(ret==TPCERROR_OK) {return(2);}

  if(verbose>1) {printf("creating test data\n"); fflush(stdout);}
  ret=create_img(&img, 4, 8, 8, 2);
  if(ret!=TPCERROR_OK) return(10);

  if(verbose>1) {printf("writing test image\n"); fflush(stdout);}
  ret=imgWriteNifti1(&img, "nii/imgwritenifti1a", status);
  if(ret!=TPCERROR_OK) {imgFree(&img); return(21);}



  imgFree(&img);
  return(0);
}
/*****************************************************************************/

/*****************************************************************************/
