#ifndef _TEST_TPCTAC_H_
#define _TEST_TPCTAC_H_
/*****************************************************************************/

/*****************************************************************************/
#include "tpcclibConfig.h"
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
/*****************************************************************************/
#include "tpctac.h"
/*****************************************************************************/

/*****************************************************************************/
/* tac */
int test_tacInit(TPCSTATUS *status);
int test_taccInit(TPCSTATUS *status);
int test_tacFreeExceptHeader(TPCSTATUS *status);
int test_tacFree(TPCSTATUS *status);
int test_taccFree(TPCSTATUS *status);
int test_tacAllocate(TPCSTATUS *status);
int test_tacAllocateMore(TPCSTATUS *status);
int test_tacCopyTacc(TPCSTATUS *status);
int test_tacCopyTaccdata(TPCSTATUS *status);
int test_tacCopyTacchdr(TPCSTATUS *status);
int test_tacCopyHdr(TPCSTATUS *status);
int test_tacIsSize(TPCSTATUS *status);
int test_tacDuplicate(TPCSTATUS *status);
int test_tacAllocateMoreSamples(TPCSTATUS *status);
/* helper functions */
int create_tac(TAC *tac);
int create_tac2(TAC *tac);
/*****************************************************************************/

/*****************************************************************************/
/* tacio */
int test_tacFormattxt(TPCSTATUS *status);
int test_tacFormatIdentify(TPCSTATUS *status);
int test_tacFormatDetermine(TPCSTATUS *status);
int test_tacFormatWriteSupported(TPCSTATUS *status);
int test_tacWrite(TPCSTATUS *status);
int test_tacRead(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* tacift */
int test_tacGetHeaderStudynr(TPCSTATUS *status);
int test_tacSetHeaderStudynr(TPCSTATUS *status);
int test_tacGetHeaderUnit(TPCSTATUS *status);
int test_tacSetHeaderUnit(TPCSTATUS *status);
int test_tacGetHeaderTimeunit(TPCSTATUS *status);
int test_tacSetHeaderTimeunit(TPCSTATUS *status);
int test_tacGetHeaderIsotope(TPCSTATUS *status);
int test_tacSetHeaderIsotope(TPCSTATUS *status);
int test_tacGetHeaderScanstarttime(TPCSTATUS *status);
int test_tacSetHeaderScanstarttime(TPCSTATUS *status);
int test_tacGetHeaderDecayCorrection(TPCSTATUS *status);
int test_tacSetHeaderDecayCorrection(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* simpleio */
int test_tacWriteSimple(TPCSTATUS *status);
int test_tacReadSimple(TPCSTATUS *status);
/*****************************************************************************/
/* dftio */
int test_tacNameSplit(TPCSTATUS *status);
int test_tacWriteDFT(TPCSTATUS *status);
int test_tacReadDFT(TPCSTATUS *status);
/*****************************************************************************/
/* sifio */
int test_tacWriteSIF(TPCSTATUS *status);
int test_tacReadSIF(TPCSTATUS *status);
/* helper functions */
int create_sif(TAC *tac);
/*****************************************************************************/
/* pmodio */
int test_tacWritePMOD(TPCSTATUS *status);
int test_tacReadPMOD(TPCSTATUS *status);
/*****************************************************************************/
/* qviewio */
int test_tacReadQView(TPCSTATUS *status);
/*****************************************************************************/
/* matio */
int test_tacReadMat(TPCSTATUS *status);
/*****************************************************************************/
/* taccsv */
int test_tacWriteCSV(TPCSTATUS *status);
int test_tacReadCSV(TPCSTATUS *status);
int test_tacReadInveonCSV(TPCSTATUS *status);
int test_tacReadCarimasTxt(TPCSTATUS *status);
/*****************************************************************************/
/* hcio */
int test_tacReadHRRTHC(TPCSTATUS *status);
int test_tacReadHRPLUSHC(TPCSTATUS *status);
/*****************************************************************************/
/* tacnan */
int test_tacXNaNs(TPCSTATUS *status);
int test_tacYNaNs(TPCSTATUS *status);
int test_tacNaNs(TPCSTATUS *status);
int test_tacNotNaNs(TPCSTATUS *status);
int test_tacFixNaNs(TPCSTATUS *status);
int test_tacNthSample(TPCSTATUS *status);
/*****************************************************************************/
/* tacselect */
int test_tacNameMatch(TPCSTATUS *status);
int test_tacSelectedTACs(TPCSTATUS *status);
int test_tacSelectTACs(TPCSTATUS *status);
int test_tacSelectBestReference(TPCSTATUS *status);
/*****************************************************************************/
/* tacorder */
int test_tacVerifyTimeOrder(TPCSTATUS *status);
int test_tacSortByTime(TPCSTATUS *status);
int test_tacSortByConc(TPCSTATUS *status);
int test_tacSortByName(TPCSTATUS *status);
int test_tacSortByAUC(TPCSTATUS *status);
int test_tacMoveTACC(TPCSTATUS *status);
int test_tacSwapTACCs(TPCSTATUS *status);
int test_tacDeleteTACC(TPCSTATUS *status);
/*****************************************************************************/
/* taccomp */
int test_tacCompareUnit(TPCSTATUS *status);
int test_tacCompareNames(TPCSTATUS *status);
int test_tacCompareConc(TPCSTATUS *status);
int test_tacCompareTimes(TPCSTATUS *status);
int test_tacCompareWeights(TPCSTATUS *status);
/*****************************************************************************/
/* tacunits */
int test_tacXUnitConvert(TPCSTATUS *status);
int test_tacYUnitConvert(TPCSTATUS *status);
int test_tacYUnitMass2Volume(TPCSTATUS *status);
int test_tacYUnitVolume2Mass(TPCSTATUS *status);
/*****************************************************************************/
/* tacname */
int test_tacIndividualNames(TPCSTATUS *status);
int test_tacEnsureNames(TPCSTATUS *status);
/*****************************************************************************/
/* tacx */
int test_tacXCopy(TPCSTATUS *status);
int test_tacDeleteFrameOverlap(TPCSTATUS *status);
int test_tacXRange(TPCSTATUS *status);
int test_tacSampleXRange(TPCSTATUS *status);
int test_tacIsX(TPCSTATUS *status);
int test_tacXMatch(TPCSTATUS *status);
int test_tacAddZeroSample(TPCSTATUS *status);
int test_tacDeleteSample(TPCSTATUS *status);
int test_tacDeleteMissingSamples(TPCSTATUS *status);
int test_tacExtractRange(TPCSTATUS *status);
int test_tacExtractSamples(TPCSTATUS *status);
int test_tacCheckX1X2X(TPCSTATUS *status);
int test_tacSetX(TPCSTATUS *status);
int test_tacGetSampleInterval(TPCSTATUS *status);
/*****************************************************************************/
/* tacy */
int test_tacYRange(TPCSTATUS *status);
int test_tacYRangeInXRange(TPCSTATUS *status);
/*****************************************************************************/
/* tacw */
int test_tacWCopy(TPCSTATUS *status);
int test_tacWMove(TPCSTATUS *status);
int test_tacWByFreq(TPCSTATUS *status);
int test_tacWSampleNr(TPCSTATUS *status);
/*****************************************************************************/
/* tacdc */
int test_tacGetIsotope(TPCSTATUS *status);
int test_tacSetIsotope(TPCSTATUS *status);
int test_tacDecayCorrection(TPCSTATUS *status);
/*****************************************************************************/
/* tacabss */
int test_tacReadAllogg(TPCSTATUS *status);
int test_tacReadOldAllogg(TPCSTATUS *status);
int test_tacReadScanditronics(TPCSTATUS *status);
int test_tacReadGEMS(TPCSTATUS *status);
/*****************************************************************************/
/* tacxmlio */
int test_tacWriteXML(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
#endif /* TEST_TPCTAC */
